#include "fractal.h"

void frac1();
void frac1_reset(struct Parameter * param);
char *frac1_name();
void frac2();
void frac2_reset(struct Parameter * param);
char *frac2_name();
void frac3();
void frac3_reset(struct Parameter * param);
char *frac3_name();
void frac4();
void frac4_reset(struct Parameter * param);
char *frac4_name();
void frac5();
void frac5_reset(struct Parameter * param);
char *frac5_name();
void frac6();
void frac6_reset(struct Parameter * param);
char *frac6_name();


void frac_reset(int fractal, struct Parameter * param) {
	if (fractal == 1)
		frac1_reset(param);
	else if (fractal == 2)
		frac2_reset(param);
	else if (fractal == 3)
		frac3_reset(param);
	else if (fractal == 4)
		frac4_reset(param);
	else if (fractal == 5)
		frac5_reset(param);
	else if (fractal == 6)
		frac6_reset(param);
	else
		frac1_reset(param);
}

void frac_draw(int fractal) {
	if (fractal == 1)
		frac1();
	else if (fractal == 2)
		frac2();
	else if (fractal == 3)
		frac3();
	else if (fractal == 4)
		frac4();
	else if (fractal == 5)
		frac5();
	else if (fractal == 6)
		frac6();
	else
		frac1();
}

char *frac_name(int fractal) {
	if (fractal == 1)
		return frac1_name();
	else if (fractal == 2)
		return frac2_name();
	else if (fractal == 3)
		return frac3_name();
	else if (fractal == 4)
		return frac4_name();
	else if (fractal == 5)
		return frac5_name();
	else if (fractal == 6)
		return frac6_name();
	else
		return frac1_name();
}

/*
 *
 *     Definice fraktalu
 *
 */


/*  fraktal jedna */

void frac1() {

	double x = 0;
	double y = 0;
	double px, py;
	double x2 = 0;
	int iter = parameter.iters;

	while (iter--){
		x2 = x;
		x = y - sin(x);
		y = parameter.alpha - x2;
	
		px = x;
		py = y;
		recalc_coords(&px, &py);

		put_pixel(px, py, iter);
	}
	
}

void frac1_reset(struct Parameter * param) {
	param->alpha = 3.099920;
	param->beta = 0;
	param->iters = 8000;
	param->zoom = 5;
	param->x = 0;
	param->y = 0;
	param->color = TRUE;
}

char *frac1_name() {
	return "Dynamic system Martin";
}

/* fraktal dva */

void frac2() {

	double x = 0;
	double y = 0;
	double x2 = 0;
	double px, py;
	int iter = parameter.iters;

	while (iter--){
		x2 = x;
		x = 1 + y - parameter.alpha * x * x;
		y = parameter.beta * x2;
	
		px = x;
		py = y;
		recalc_coords(&px, &py);
		put_pixel(px, py, iter);
	}
	
}

void frac2_reset(struct Parameter * param) {
	param->alpha = 1.4;
	param->beta = 0.3;
	param->iters = 3000;
	param->zoom = 130;
	param->x = 0;
	param->y = 0;
	param->color = FALSE;
}

char *frac2_name() {
	return "Henon's attractor";
}

/* fraktal tri */

void frac3() {


	int i, j;
	double a, b, c, d;
	double x, y;
	int k;
	
	for (i = 0; i < parameter.width; i++)
		for (j = 0; j < parameter.height; j++) {
			a = b = 0;
			x = i;
			y = j;
			recalc_coords_rev(&x, &y);
			for (k = 0; k < parameter.iters; k++) {
				c = a * a;
				d = b * b;
				if (c + d > parameter.alpha)
					break;
				b = parameter.beta * a * b + y;
				a = c - d + x;
			}
			if (k != parameter.iters)
				put_pixel(i, j, k);
		}

}

void frac3_reset(struct Parameter * param) {
	param->alpha = 50;
	param->beta = 2;
	param->iters = 50;
	param->zoom = 200;
	param->x = 0.25;
	param->y = 0;
	param->color = TRUE;
}

char *frac3_name() {
	return "Mandelbrot";
}

/*  fraktal ctyri */

void frac4() {

	double x = 0;
	double y = 0;
	double a = parameter.alpha;
	double b = parameter.beta;
	double c = 0;
	double px, py;
	double x2 = 0;
	int iter = parameter.iters;

	while (iter--) {
		x2 = x;
		if (x > 0)
			x = y - sqrt (fabs (b * x - c));
		else
			x = y + sqrt (fabs (b * x - c));
		y = a - x2;

		px = x;
		py = y;
		recalc_coords(&px, &py);

		put_pixel(px, py, iter);
	}
	
}

void frac4_reset(struct Parameter * param) {
	param->alpha = 0.4;
	param->beta = 1.0;
	param->iters = 80000;
	param->zoom = 160;
	param->x = 0;
	param->y = -0.5;
	param->color = TRUE;
}

char *frac4_name() {
	return "Dynamic system Hopalong";
}

/*  fraktal pet */

void frac5() {
	/* kresleno v plose */

	double x = 0;
	double y = 0;
	double z = 0;
	double a = parameter.alpha;
	double b = parameter.beta;
	double c = -0.65;
	double d = -2.43;
	double px, py;
	double x2, y2, z2;
	int iter = parameter.iters;

	while (iter--) {
		x2=sin(a*y)-z*cos(b*x);
		y2=z*sin(c*x)-cos(d*y);
		z2=sin(x);
		x=x2;
		y=y2;
		z=z2;

		px = x;
		py = y;
		recalc_coords(&px, &py);

		put_pixel(px, py, iter);
	}
	
}

void frac5_reset(struct Parameter * param) {
	param->alpha = 2.24;
	param->beta = 0.43;
	param->iters = 80000;
	param->zoom = 160;
	param->x = 0;
	param->y = 0;
	param->color = FALSE;
}

char *frac5_name() {
	return "Dynamic system Pickover";
}

/* fraktal sest */

void frac6() {


	int i, j;
	double a, b, c, d;
	double x, y;
	int k;
	
	for (i = 0; i < parameter.width; i++)
		for (j = 0; j < parameter.height; j++) {
			a = b = 0;
			x = i;
			y = j;
			recalc_coords_rev(&x, &y);
			for (k = 0; k < parameter.iters; k++) {
				c = a * a;
				d = b * b;
				if (c+d > parameter.alpha)
					break;
				b = parameter.beta * a * b + y;
				a = c - d + x;
				if (k > 20)
					put_pixel(i, j, k);
					/* (cy-MINY)*255.0/(MAXY-MINY), iter*255.0/maxiter, (cx-MINX)*255.0/(MAXX-MINX)) */
			}
		}

}

void frac6_reset(struct Parameter * param) {
	param->alpha = 50;
	param->beta = 2;
	param->iters = 50;
	param->zoom = 200;
	param->x = 0.25;
	param->y = 0;
	param->color = TRUE;
}

char *frac6_name() {
	return "Mandelbrot 2";
}
